<?php

namespace FiloBlu\Flow\Model\Actions\From;

class Addrelated {

    CONST ENTITY_TYPE_CODE = 'catalog_product';

    protected $_helper_product;
    protected $_model_product;

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Product $helper_product,
        \Magento\Catalog\Model\Product $model_product,
        array $data = []
    ) {
        $this->helper_product = $_helper_product;
        $this->_model_product = $model_product;
    }

    public static function process($product, $value, $storeId) {

        if (empty($value)) {
            return true;
        }

        \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Store\Model\StoreManagerInterface')->setCurrentStore($storeId);
        if ($storeId != 0) {
            return "The function is avalaible only for the ADMIN store.";
        }

        $_related = array();

        // controllo se si tratta di più related con separatore |
        $_related_sku = array();
        if(strrpos($value, '|')) {
            $_related_sku = explode( '|', $value);
        } else {
            $_related_sku[] = $value;
        }
        if(is_array($_related_sku) && count($_related_sku)>=1) {

            $linkDataAll = array();

            foreach($_related_sku as $_related) {

                //check first if the product exist
                $linkedProduct = $this->_model_product->create()->loadByAttribute("sku",$_related);
                if($linkedProduct) {
                   /** @var  \Magento\Catalog\Api\Data\ProductLinkInterface $productLinks */
                   $productLinks = $obj->create('Magento\Catalog\Api\Data\ProductLinkInterface');
                   $linkData = $productLinks
                       ->setSku($product->getSku())
                       ->setLinkedProductSku($_related)
                       ->setLinkType("related");
                   $linkDataAll[] = $linkData;
               }

            }

            if($linkDataAll) {
                $product->setProductLinks($linkDataAll);
            }
         $product->save();

        }



        // mettere in configurazione se i related devono essere salvati anche su configurabile - default YES
        if ($product->getTypeId() == \Magento\Catalog\Model\Product\Type::DEFAULT_TYPE) {
            $parentIds = \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\ConfigurableProduct\Model\ResourceModel\Product\Type\Configurable')
                ->getParentIdsByChild($product->getId());
            if (count($parentIds) <= 0)
                return true;

            foreach ($parentIds as $parentId) {
                $parent_product = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Catalog\Model\Product')->load($parentId);

                if(is_array($_related_sku) && count($_related_sku)>=1) {

                    $linkDataAll = array();

                    foreach($_related_sku as $_related) {

                        //check first if the product exist
                        $linkedProduct = $this->_model_product->create()->loadByAttribute("sku",$_related);
                        if($linkedProduct) {
                           /** @var  \Magento\Catalog\Api\Data\ProductLinkInterface $productLinks */
                           $productLinks = $obj->create('Magento\Catalog\Api\Data\ProductLinkInterface');
                           $linkData = $productLinks
                               ->setSku($parent_product->getSku())
                               ->setLinkedProductSku($_related)
                               ->setLinkType("related");
                           $linkDataAll[] = $linkData;
                       }

                    }

                    if($linkDataAll) {
                        $parent_product->setProductLinks($linkDataAll);
                    }
                 $parent_product->save();

                }
            }

        }

    }

}
